diff --git a/xlators/cluster/dht/src/dht-common.h b/xlators/cluster/dht/src/dht-common.h
index 2f23601d640..c3ad0295370 100644
--- a/xlators/cluster/dht/src/dht-common.h
+++ b/xlators/cluster/dht/src/dht-common.h
@@ -533,7 +533,6 @@ struct dht_conf {
     int32_t refresh_interval;
     gf_lock_t subvolume_lock;
     time_t last_stat_fetch;
-    gf_lock_t layout_lock;
     dict_t *leaf_to_subvol;
     void *private; /* Can be used by wrapper xlators over
                       dht */
diff --git a/xlators/cluster/dht/src/dht-layout.c b/xlators/cluster/dht/src/dht-layout.c
index 4706135f1d1..ec5d5ac351a 100644
--- a/xlators/cluster/dht/src/dht-layout.c
+++ b/xlators/cluster/dht/src/dht-layout.c
@@ -56,11 +56,23 @@ dht_layout_get(xlator_t *this, inode_t *inode)
 {
     dht_layout_t *layout = NULL;
     int ret = 0;
+    uint64_t ctx_int = 0;
+    dht_inode_ctx_t *ctx = NULL;
 
-    ret = dht_inode_ctx_layout_get(inode, this, &layout);
-    if ((!ret) && layout) {
-        GF_ATOMIC_INC(layout->ref);
+    LOCK(&inode->lock);
+    {
+        ret = __inode_ctx_get(inode, this, &ctx_int);
+        if (!ret) {
+            ctx = (dht_inode_ctx_t *)(uintptr_t)ctx_int;
+            if (ctx && ctx->layout) {
+                layout = ctx->layout;
+                if (layout)
+                    GF_ATOMIC_INC(layout->ref);
+            }
+        }
     }
+    UNLOCK(&inode->lock);
+
     return layout;
 }
 
@@ -68,29 +80,47 @@ int
 dht_layout_set(xlator_t *this, inode_t *inode, dht_layout_t *layout)
 {
     dht_conf_t *conf = NULL;
-    int oldret = -1;
     int ret = -1;
     dht_layout_t *old_layout;
+    uint64_t ctx_int = 0;
+    dht_inode_ctx_t *ctx = NULL;
 
     conf = this->private;
     if (!conf || !layout)
         goto out;
 
-    LOCK(&conf->layout_lock);
+    LOCK(&inode->lock);
     {
-        oldret = dht_inode_ctx_layout_get(inode, this, &old_layout);
+        ret = __inode_ctx_get(inode, this, &ctx_int);
+        if (!ret) {
+            ctx = (dht_inode_ctx_t *)(uintptr_t)ctx_int;
+            if (ctx && ctx->layout) {
+                old_layout = ctx->layout;
+                if (old_layout)
+                    dht_layout_unref(old_layout);
+            }
+        }
+
         if (layout)
             GF_ATOMIC_INC(layout->ref);
-        ret = dht_inode_ctx_layout_set(inode, this, layout);
-    }
-    UNLOCK(&conf->layout_lock);
-
-    if (!oldret) {
-        dht_layout_unref(old_layout);
-    }
-    if (ret)
-        GF_ATOMIC_DEC(layout->ref);
 
+        if (ctx) {
+            ctx->layout = layout;
+        } else {
+            ctx = GF_CALLOC(1, sizeof(*ctx), gf_dht_mt_inode_ctx_t);
+            if (!ctx) {
+                GF_ATOMIC_DEC(layout->ref);
+                ret = -1;
+            } else {
+                ctx->layout = layout;
+                ctx_int = (long)ctx;
+                ret = __inode_ctx_set0(inode, this, &ctx_int);
+                if (ret)
+                    GF_ATOMIC_DEC(layout->ref);
+           }
+       }
+    }
+    UNLOCK(&inode->lock);
 out:
     return ret;
 }
@@ -704,6 +734,8 @@ dht_layout_preset(xlator_t *this, xlator_t *subvol, inode_t *inode)
     dht_layout_t *layout = NULL;
     int ret = -1;
     dht_conf_t *conf = NULL;
+    uint64_t ctx_int = 0;
+    dht_inode_ctx_t *ctx = NULL;
 
     conf = this->private;
     if (!conf)
@@ -720,14 +752,28 @@ dht_layout_preset(xlator_t *this, xlator_t *subvol, inode_t *inode)
     gf_msg_debug(this->name, 0, "file = %s, subvol = %s",
                  uuid_utoa(inode->gfid), subvol ? subvol->name : "<nil>");
 
-    LOCK(&conf->layout_lock);
+
+    LOCK(&inode->lock);
     {
-        dht_inode_ctx_layout_set(inode, this, layout);
-    }
+        ret = __inode_ctx_get(inode, this, &ctx_int);
+        if (!ret) {
+            ctx = (dht_inode_ctx_t *)(uintptr_t)ctx_int;
+            if (ctx) {
+                ctx->layout = layout;
+            }
+        }
 
-    UNLOCK(&conf->layout_lock);
+        if (!ctx) {
+            ctx = GF_CALLOC(1, sizeof(*ctx), gf_dht_mt_inode_ctx_t);
+            if (ctx) {
+                ctx->layout = layout;
+                ctx_int = (long)ctx;
+                ret = __inode_ctx_set0(inode, this, &ctx_int);
+            }
+        }
 
-    ret = 0;
+    }
+    UNLOCK(&inode->lock);
 out:
     return ret;
 }
diff --git a/xlators/cluster/dht/src/dht-shared.c b/xlators/cluster/dht/src/dht-shared.c
index a2c5d40f476..914d2f8e710 100644
--- a/xlators/cluster/dht/src/dht-shared.c
+++ b/xlators/cluster/dht/src/dht-shared.c
@@ -643,7 +643,6 @@ dht_init(xlator_t *this)
     }
 
     LOCK_INIT(&conf->subvolume_lock);
-    LOCK_INIT(&conf->layout_lock);
     LOCK_INIT(&conf->lock);
     synclock_init(&conf->link_lock, SYNC_LOCK_DEFAULT);
 
